poj 2567 zzu10395 nyoj1254 Code the Tree(Prufer数列)

2024-02-09 15:48

本文主要是介绍poj 2567 zzu10395 nyoj1254 Code the Tree(Prufer数列),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Description:

A tree (i.e. a connected graph without cycles) with vertices numbered by the integers 1, 2, …, n is given. The “Prufer” code of such a tree is built as follows: the leaf (a vertex that is incident to only one edge) with the minimal number is taken. This leaf, together with its incident edge is removed from the graph, while the number of the vertex that was adjacent to the leaf is written down. In the new obtained tree, this procedure is repeated, until there is only one vertex left (which, by the way, always has number n). The written down sequence of n-1 numbers is called the Prufer code of the tree.
Your task is, given a tree, to compute its Prufer code. The tree is denoted by a word of the language specified by the following grammar:

T ::= “(” N S “)”

S ::= ” ” T S | empty

N ::= number

That is, trees have parentheses around them, and a number denoting the identifier of the root vertex, followed by arbitrarily many (maybe none) subtrees separated by a single space character. As an example, take a look at the tree in the figure below which is denoted in the first line of the sample input. To generate further sample input, you may use your solution to Problem 2568.
Note that, according to the definition given above, the root of a tree may be a leaf as well. It is only for the ease of denotation that we designate some vertex to be the root. Usually, what we are dealing here with is called an “unrooted tree”.

Input

The input contains several test cases. Each test case specifies a tree as described above on one line of the input file. Input is terminated by EOF. You may assume that 1<=n<=50

Output

For each test case generate a single line containing the Prufer code of the specified tree. Separate numbers by a single space. Do not print any spaces at the end of the line.

Sample Input

(2 (6 (7)) (3) (5 (1) (4)) (8))
(1 (2 (3)))

Sample Output

5 2 5 2 6 2 8
2 3

做这道题真是一波三折。。起初用Vector邻接表 wa了 自己就想当然的想了一组数据(1(1)(2)) vecotr邻接表 肯定是wa了。所以就用指针做了。 后来才发现 vector邻接表是这组数据错了(5(1(3(6)))) ,测试数组给的并没有重复的数字 还是没有好好理解好题意 。
指针做的比较难懂,我最下面也把vector邻接表做的贴上吧

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
using namespace std;
struct node
{int num,index;node *next[55],*pre;node(){for(int i=0;i<55;i++)next[i]=NULL;num=index=0;pre=NULL;}
};
node *MIN;//存贮最小的叶子节点的指针 
int zuixiao;
void freenode(node *node)
{node=NULL;delete(node);
}
//深搜查找最小的叶子 
void dfs(node *root)
{if(root->index==0&&zuixiao>root->num){zuixiao=root->num;MIN=root;return ;}for(int i=1;i<=root->index;i++){dfs(root->next[i]);}
}
int main(){
//  freopen("in.txt","r",stdin);char str[250];while(gets(str)!=NULL){node *root=new node();root->num=-1;int len=strlen(str);bool isnum=false;int sum=0;int cnt=-1;for(int i=0;i<len;i++){isnum=false;sum=0;while(str[i]>='0'&&str[i]<='9'){isnum=true;sum=sum*10+str[i++]-'0';}if(isnum){root->index++,cnt++;;root->next[root->index]=new node();root->next[root->index]->pre=root;root->next[root->index]->num=sum;root=root->next[root->index];}if(str[i]==')'&&root->pre){root=root->pre;}}bool first=true;node *FA;while(cnt--){zuixiao=0x3fffffff;//这一点Wa了我一整天啊 一整天  //如果根节点下面只有一个子树,那么这个根节点也可能成为叶子节点 if(root->next[1]->index==1){zuixiao=root->next[1]->num;MIN=root->next[1];}dfs(root);FA=MIN->pre;if(FA==root){FA=root->next[1]=MIN->next[1];MIN->next[1]->pre=root; }else{for(int i=1;i<=FA->index;i++){//(5(1(3(6))))if(FA->next[i]==MIN){FA->next[i]=FA->next[FA->index];freenode(FA->next[FA->index]);FA->index--;break;}}}if(first)printf("%d",FA->num),first=false;elseprintf(" %d",FA->num);freenode(FA);freenode(MIN);}printf("\n");   freenode(root);}
}     
#include <stdio.h>
#include <vector>
#include <stack>
#include <string.h>
using namespace std;
vector<int>link[250];
stack<int>s;
int fa,zuixiao,x;
void dfs(int child,int father){for(int i=0;i<link[child].size();i++){int j=link[child][i];if(link[j].size()==0&&child!=200){if(zuixiao>j){zuixiao=j;fa=child;}}elsedfs(j,child);}
}
int main(){char str[500];while(gets(str)!=NULL){memset(link,0,sizeof(link));while(!s.empty()) s.pop();int len=strlen(str);bool isnum=false;int sum=0;int cnt=-1;s.push(200);for(int i=0;i<len;i++){isnum=false;sum=0;while(str[i]>='0'&&str[i]<='9'){isnum=true;sum=sum*10+str[i]-'0';i++;}if(isnum){cnt++;link[s.top()].push_back(sum);s.push(sum);}if(str[i]==')')s.pop();}bool first=true;while(cnt--){zuixiao=0x3fffffff;if(link[link[200][0]].size()==1)zuixiao=link[200][0];dfs(200,200);if(zuixiao==link[200][0]){fa=link[zuixiao][0];link[200].clear();link[200].push_back(fa);}else{for(int i=0;i<link[fa].size();i++){if(link[fa][i]==zuixiao)link[fa].erase(link[fa].begin()+i);}}if(first)printf("%d",fa),first=false;elseprintf(" %d",fa);}printf("\n");}
}

这篇关于poj 2567 zzu10395 nyoj1254 Code the Tree(Prufer数列)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/694636

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i